structure GM :> GM =
struct

structure RVar = DRVar

structure Potential = DPotentialFn(structure RVar=RVar)

structure IPotential = DIPotentialFn(structure RVar=RVar 
				     structure Table=Table)

structure CPD = DCPDFn(structure RVar=RVar)

structure LocalFactor = DLocalFactorFn(structure RVar=RVar 
				       structure CPD=CPD
				       structure Potential=Potential
				       structure IPotential=IPotential)

structure GModel = DGModelFn(structure LocalFactor=LocalFactor
			     structure IP=IPotential
			     structure RVar=RVar)

structure NaiveInfer = NaiveInferFn(structure GModel=GModel
				    structure RVar = RVar
				    structure IP = IPotential)

structure VarElimInfer = VarElimInferFn(structure GModel=GModel
					structure RVar = RVar
					structure IP = IPotential)

structure JoinTreeInfer = JoinTreeInferFn(structure GModel=GModel
					  structure RVar = RVar
					  structure IP = IPotential)

structure LazyInfer = LazyInferFn(structure GModel=GModel
				  structure RVar = RVar
				  structure IP = IPotential)

structure ParamLearn = ParamLearnFn(structure GModel=GModel
				    structure RVar = RVar
				    structure IP = IPotential)

(* This can be suplemented to add ... *)
fun main (_,_) =
    let
	val _ =  print "hello world\n"
    in
	OS.Process.success
    end
	
			  
end
