(* D_POTENTIAL : A potential over discrete variables

  This module provides the specification of discrete potentials.
*) 

signature D_POTENTIAL =
sig

    structure RVar : D_R_VAR

    type pot
	 
    val make : (real list * RVar.var list) -> pot
					     
    val getScope : pot -> RVar.var list

    val getEntries : pot -> real list

end
